/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM $SRCDIR/comm/mailnews/addrbook/public/nsIAddrDatabase.idl
 */

#ifndef __gen_nsIAddrDatabase_h__
#define __gen_nsIAddrDatabase_h__


#ifndef __gen_nsIAbCard_h__
#include "nsIAbCard.h"
#endif

#ifndef __gen_nsIAbDirectory_h__
#include "nsIAbDirectory.h"
#endif

#include "js/GCAnnotations.h"

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIFile; /* forward declaration */

class nsIMdbRow;
class nsISimpleEnumerator; /* forward declaration */

// this is the prefix we for attributes that are specific
// to the mozilla addressbook, and weren't in 4.x and aren't specified in
// RFC 2789.  used when exporting and import LDIF
// see nsTextAddress.cpp, nsAddressBook.cpp
#define MOZ_AB_LDIF_PREFIX "mozilla"
// note, GeneratedName is not a real column
// if you change any of this, make sure to change
// Get / Set CardValue in nsAbCardProperty.cpp
#define kPhoneticNameColumn       "_PhoneticName"
#define kAddressCharSetColumn     "AddrCharSet"
#define kMailListName             "ListName"
#define kMailListNickName         "ListNickName"
#define kMailListDescription      "ListDescription"
#define kMailListTotalAddresses   "ListTotalAddresses"
// not shown in the UI
#define kLowerPriEmailColumn      "LowercasePrimaryEmail"
#define kLower2ndEmailColumn      "LowercaseSecondEmail"
// Palm Integration
#define  CARD_ATTRIB_PALMID "PalmRecId"
#define  CARD_ATTRIB_DISPLAY "DisplayName"

/* starting interface:    nsAddrDBCommitType */
#define NS_ADDRDBCOMMITTYPE_IID_STR "20d4c6c3-0460-403e-aa9c-813654641566"

#define NS_ADDRDBCOMMITTYPE_IID \
  {0x20d4c6c3, 0x0460, 0x403e, \
    { 0xaa, 0x9c, 0x81, 0x36, 0x54, 0x64, 0x15, 0x66 }}

class NS_NO_VTABLE nsAddrDBCommitType : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ADDRDBCOMMITTYPE_IID)

  enum {
    kLargeCommit = 1,
    kSessionCommit = 2,
    kCompressCommit = 3
  };

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsAddrDBCommitType, NS_ADDRDBCOMMITTYPE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSADDRDBCOMMITTYPE \

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSADDRDBCOMMITTYPE \

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSADDRDBCOMMITTYPE(_to) \

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSADDRDBCOMMITTYPE(_to) \


/* starting interface:    nsIAddrDatabase */
#define NS_IADDRDATABASE_IID_STR "c54973e4-d251-4b93-a0d0-81a616225061"

#define NS_IADDRDATABASE_IID \
  {0xc54973e4, 0xd251, 0x4b93, \
    { 0xa0, 0xd0, 0x81, 0xa6, 0x16, 0x22, 0x50, 0x61 }}

class NS_NO_VTABLE nsIAddrDatabase : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IADDRDATABASE_IID)

  /* attribute nsIFile dbPath; */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD GetDbPath(nsIFile **aDbPath) = 0;
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD SetDbPath(nsIFile *aDbPath) = 0;

  /* nsIAddrDatabase open (in nsIFile dbFile, in boolean create, in boolean upgrading); */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD Open(nsIFile *dbFile, bool create, bool upgrading, nsIAddrDatabase **_retval) = 0;

  /* void close (in boolean forceCommit); */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD Close(bool forceCommit) = 0;

  /* void openMDB (in nsIFile dbName, in boolean create); */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD OpenMDB(nsIFile *dbName, bool create) = 0;

  /* void closeMDB (in boolean commit); */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD CloseMDB(bool commit) = 0;

  /* void forceClosed (); */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD ForceClosed(void) = 0;

  /* nsISimpleEnumerator enumerateCards (in nsIAbDirectory directory); */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD EnumerateCards(nsIAbDirectory *directory, nsISimpleEnumerator **_retval) = 0;

  /* nsISimpleEnumerator enumerateListAddresses (in nsIAbDirectory directory, in unsigned long listRowID); */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD EnumerateListAddresses(nsIAbDirectory *directory, uint32_t listRowID, nsISimpleEnumerator **_retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIAddrDatabase, NS_IADDRDATABASE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIADDRDATABASE \
  NS_IMETHOD GetDbPath(nsIFile **aDbPath) override; \
  NS_IMETHOD SetDbPath(nsIFile *aDbPath) override; \
  NS_IMETHOD Open(nsIFile *dbFile, bool create, bool upgrading, nsIAddrDatabase **_retval) override; \
  NS_IMETHOD Close(bool forceCommit) override; \
  NS_IMETHOD OpenMDB(nsIFile *dbName, bool create) override; \
  NS_IMETHOD CloseMDB(bool commit) override; \
  NS_IMETHOD ForceClosed(void) override; \
  NS_IMETHOD EnumerateCards(nsIAbDirectory *directory, nsISimpleEnumerator **_retval) override; \
  NS_IMETHOD EnumerateListAddresses(nsIAbDirectory *directory, uint32_t listRowID, nsISimpleEnumerator **_retval) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIADDRDATABASE \
  nsresult GetDbPath(nsIFile **aDbPath); \
  nsresult SetDbPath(nsIFile *aDbPath); \
  nsresult Open(nsIFile *dbFile, bool create, bool upgrading, nsIAddrDatabase **_retval); \
  nsresult Close(bool forceCommit); \
  nsresult OpenMDB(nsIFile *dbName, bool create); \
  nsresult CloseMDB(bool commit); \
  nsresult ForceClosed(void); \
  nsresult EnumerateCards(nsIAbDirectory *directory, nsISimpleEnumerator **_retval); \
  nsresult EnumerateListAddresses(nsIAbDirectory *directory, uint32_t listRowID, nsISimpleEnumerator **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIADDRDATABASE(_to) \
  NS_IMETHOD GetDbPath(nsIFile **aDbPath) override { return _to GetDbPath(aDbPath); } \
  NS_IMETHOD SetDbPath(nsIFile *aDbPath) override { return _to SetDbPath(aDbPath); } \
  NS_IMETHOD Open(nsIFile *dbFile, bool create, bool upgrading, nsIAddrDatabase **_retval) override { return _to Open(dbFile, create, upgrading, _retval); } \
  NS_IMETHOD Close(bool forceCommit) override { return _to Close(forceCommit); } \
  NS_IMETHOD OpenMDB(nsIFile *dbName, bool create) override { return _to OpenMDB(dbName, create); } \
  NS_IMETHOD CloseMDB(bool commit) override { return _to CloseMDB(commit); } \
  NS_IMETHOD ForceClosed(void) override { return _to ForceClosed(); } \
  NS_IMETHOD EnumerateCards(nsIAbDirectory *directory, nsISimpleEnumerator **_retval) override { return _to EnumerateCards(directory, _retval); } \
  NS_IMETHOD EnumerateListAddresses(nsIAbDirectory *directory, uint32_t listRowID, nsISimpleEnumerator **_retval) override { return _to EnumerateListAddresses(directory, listRowID, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIADDRDATABASE(_to) \
  NS_IMETHOD GetDbPath(nsIFile **aDbPath) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDbPath(aDbPath); } \
  NS_IMETHOD SetDbPath(nsIFile *aDbPath) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDbPath(aDbPath); } \
  NS_IMETHOD Open(nsIFile *dbFile, bool create, bool upgrading, nsIAddrDatabase **_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Open(dbFile, create, upgrading, _retval); } \
  NS_IMETHOD Close(bool forceCommit) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Close(forceCommit); } \
  NS_IMETHOD OpenMDB(nsIFile *dbName, bool create) override { return !_to ? NS_ERROR_NULL_POINTER : _to->OpenMDB(dbName, create); } \
  NS_IMETHOD CloseMDB(bool commit) override { return !_to ? NS_ERROR_NULL_POINTER : _to->CloseMDB(commit); } \
  NS_IMETHOD ForceClosed(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ForceClosed(); } \
  NS_IMETHOD EnumerateCards(nsIAbDirectory *directory, nsISimpleEnumerator **_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->EnumerateCards(directory, _retval); } \
  NS_IMETHOD EnumerateListAddresses(nsIAbDirectory *directory, uint32_t listRowID, nsISimpleEnumerator **_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->EnumerateListAddresses(directory, listRowID, _retval); } 


#endif /* __gen_nsIAddrDatabase_h__ */
